# First run: Learns useless shit
# Second run: Learns a mediocre blub

target_audio:
  # An audio file stored in the sounds directory
  name: synthetic/multiple_oscillations
  sample_rate: 44100


evolutionary_algorithm:
  population_size: 500
  generation_count: 300
  # After this many generations without an improvement in the solution, the process is stopped prematurely.
  early_stopping: 70

  operators:
    # When two individuals are selected for crossover, a random operator listed here
    # will be applied.
    crossover:
      # Select one node in each parent and exchange the subtrees
      # - one_point
      # Combine the trees from the parents using a randomly picked binary non-terminal.
      # When using the JAX implementation, parameters are selected using simulated binary crossover.
      - merge
      # Same as merge operator, but only allows +, -, * as operations for merging trees.
      # - merge_arithmetic
      # Perform simulated binary crossover on the parameter set. Only applicable to JAX implementation.
      # - parameter_simulated_binary
    # When two individuals are selected for mutation, a random operator listed here
    # will be applied.
    mutation:
      # Select a random node and replace it with a newly generated subtree.
      # - uniform
      # Select a random non-terminal and replace it with one of its arguments.
      # - shrink
      # Select a random non-terminal and replace it with a different non-terminal of the same arity.
      # - replace
      # Insert a new branch at a random position that uses the old tree as a subtree.
      # - insert
      # Select a random node, weighed by the layer with 1/3^depth, and replace it by a random subtree.
      - layer_weighted
      # Randomly regenerate the parameters (same as initialization). Only applicable to the JAX implementation.
      # - parameter_reroll
      # Randomly regenerate ephemeral parameters according to the supercollider.eph_mode value.
      # Only applicable to SuperCollider implementation
      - ephemeral
    # Probabilities of the applying any of the operators.
    crossover_probability: 0.5
    mutation_probability: 0.5


  fitness_function:
    # l1, l1, l1_l2
    distance: l1
    # One of mel, mfcc, mel_db
    feature: mel_db

  # Only relevant if no helper-objective is used, as otherwise NSGA2 selection is done
  selection:
    # tournament, double_tournament, rank_double_tournament
    scheme: rank_double_tournament
    fitness_tournament_size: 3
    # A number in [1, 2]. The smaller individual is selected with a probability of size_tournament_size/2
    # Only used in the double tournament schemes.
    size_tournament_size: 1.2
    # Corresponds to (not) using k-elitism
    hall_of_fame_size: 5

  genetic_programming:
    tree_depth:
      initial:
        min: 1
        max: 3
      # Limit on the tree depth that can be reached during learning.
      # The hard limit here is 90, as that is the maximum call stack depth Python permits.
      max: 17

supercollider:
  # The SC implementation uses ephemeral constants, which have their own mutation.
  # There are the modes all or one for this mutation.
  eph_mode: "all"

jax:
  use_jax_implementation: no
  # The JAX implementation uses a set of parameters instead of random
  # constants in the tree. These get their own simulated binary crossover
  # and mutation (reinitializing random values) as an extra step.
  parameter_count: 5
  simulated_binary_crossover_eta: 2
  lifetime_learning:
    individual_count: 10
    gradient_descent_steps: 200
    # Starting learning rate for the Adam optimizer
    initial_learning_rate: 5e-4

multi_objective:
  # Possible values: mfcc, zero_crossings, or empty.
  helper_objective: mfcc
  zero_crossings_histogram_bin_count: 50
  nd_rank_double_tournament_selection:


log_mode: pickle